#pragma once

#include "CoreMinimal.h"
#include "InteractionDefinition.h"
#include "DBDTunableRowHandle.h"
#include "Templates/SubclassOf.h"
#include "TrapSurvivorInteraction.generated.h"

class UStatusEffect;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class UTrapSurvivorInteraction : public UInteractionDefinition
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TArray<FString> _nonOverridableInteractions;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _trapAttachSocket;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _updateMontageID;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _updateNoScreamMontageID;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _loudNoiseRangeTunable;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _hemorrhageEffectDurationTunable;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UStatusEffect> _hemorrhageStatusEffect;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UStatusEffect> _mangledStatusEffect;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UStatusEffect> _honingStoneWarningStatusEffect;

public:
	UTrapSurvivorInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UTrapSurvivorInteraction) { return 0; }
